using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace JelliesAPlenty.Sprite
{
    class Sprite
    {

        public Sprite(string theTextureKey, Rectangle theLocationAndSize)
        {
            TextureKey = theTextureKey;
            Position = new Vector2(theLocationAndSize.X, theLocationAndSize.Y);
            Width = theLocationAndSize.Width;
            Height = theLocationAndSize.Height;
        }


        public Sprite(string theTextureKey, Rectangle theLocationAndSize, Vector2 theGridPosition)
        {
            TextureKey = theTextureKey;
            Position = new Vector2(theLocationAndSize.X, theLocationAndSize.Y);
            Width = theLocationAndSize.Width;
            Height = theLocationAndSize.Height;

            GridPosition = theGridPosition;
        }

        public Sprite(string theTextureKey, Rectangle theLocationAndSize, Rectangle theTextureLocation)
        {
            TextureKey = theTextureKey;
            Position = new Vector2(theLocationAndSize.X, theLocationAndSize.Y);
            Width = theLocationAndSize.Width;
            Height = theLocationAndSize.Height;

            TexturePositionX = theTextureLocation.X;
            TexturePositionY = theTextureLocation.Y;
            TextureWidth = theTextureLocation.Width;
            TextureHeight = theTextureLocation.Height;
        }

        public Sprite(string theTextureKey, Rectangle theLocationAndSize, Rectangle theTextureLocation, Vector2 theGridPosition)
        {
            TextureKey = theTextureKey;
            Position = new Vector2(theLocationAndSize.X, theLocationAndSize.Y);
            Width = theLocationAndSize.Width;
            Height = theLocationAndSize.Height;

            TexturePositionX = theTextureLocation.X;
            TexturePositionY = theTextureLocation.Y;
            TextureWidth = theTextureLocation.Width;
            TextureHeight = theTextureLocation.Height;

            GridPosition = theGridPosition;
        }


        public Sprite(string theTextureKey, Rectangle theLocationAndSize, bool isVisible)
        {
            TextureKey = theTextureKey;
            Position = new Vector2(theLocationAndSize.X, theLocationAndSize.Y);
            Width = theLocationAndSize.Width;
            Height = theLocationAndSize.Height;
            Visible = isVisible;
        }

        public Sprite(string theTextureKey, Rectangle theLocationAndSize, Rectangle theTextureLocation, bool isVisible)
        {
            TextureKey = theTextureKey;
            Position = new Vector2(theLocationAndSize.X, theLocationAndSize.Y);
            Width = theLocationAndSize.Width;
            Height = theLocationAndSize.Height;

            TexturePositionX = theTextureLocation.X;
            TexturePositionY = theTextureLocation.Y;
            TextureWidth = theTextureLocation.Width;
            TextureHeight = theTextureLocation.Height;
            
            Visible = isVisible;
         }


         public Sprite(string theTextureKey, Rectangle theLocationAndSize, bool isVisible, Vector2 theGridPosition)
         {
             TextureKey = theTextureKey;
             Position = new Vector2(theLocationAndSize.X, theLocationAndSize.Y);
             Width = theLocationAndSize.Width;
             Height = theLocationAndSize.Height;
             Visible = isVisible;

             GridPosition = theGridPosition;
         }

         public Sprite(string theTextureKey, Rectangle theLocationAndSize, Rectangle theTextureLocation, bool isVisible, Vector2 theGridPosition)
         {
             TextureKey = theTextureKey;
             Position = new Vector2(theLocationAndSize.X, theLocationAndSize.Y);
             Width = theLocationAndSize.Width;
             Height = theLocationAndSize.Height;

             TexturePositionX = theTextureLocation.X;
             TexturePositionY = theTextureLocation.Y;
             TextureWidth = theTextureLocation.Width;
             TextureHeight = theTextureLocation.Height;

             Visible = isVisible;

             GridPosition = theGridPosition;
         }

        private string mTextureKey;
        public string TextureKey
        {
            get
            {
                return mTextureKey;
            }
            set
            {
                mTextureKey = value;
            }
        }//End TextureKey Property

        //The X,Y position of the Sprite
        private Vector2 mPosition;
        public Vector2 Position
        {
            get
            {
                return mPosition;
            }
            set
            {
                mPosition = value;
            }
        }//End Position Property

        private int mWidth;
        public int Width
         {
            get
            {
                return mWidth;
            }
            set
            {
                mWidth = value;
            }
        }//End Width Property

        private int mHeight;
        public int Height
        {
            get
            {
                return mHeight;
            }
            set
            {
                mHeight = value;
            }
        }//End Height Property
        
        private int mTexturePositionX = 0;
        public int TexturePositionX
        {
            get
            {
                return mTexturePositionX;
            }
            set
            {
                mTexturePositionX = value;
            }
        }

        private int mTexturePositionY = 0;
        public int TexturePositionY
        {
            get
            {
                return mTexturePositionY;
            }
            set
            {
                mTexturePositionY = value;
            }
        }

        private int mTextureWidth = 0;
        public int TextureWidth
           {
            get
            {
                return mTextureWidth;
            }
            set
            {
                mTextureWidth = value;
            }
        }//End Width Property

        private int mTextureHeight = 0;
        public int TextureHeight
        {
            get
            {
                return mTextureHeight;
            }
            set
            {
                mTextureHeight = value;
            }
        }//End TextureHeight Property


        private bool mVisible = false;
        public bool Visible
        {
            get
            {
                return mVisible;
            }
            set
            {
                mVisible = value;
                if (mVisible == true && VisibleTime != 0 && Elapsed == 0)
                {
                    //Reset the time for the image to be viisble
                    Elapsed = VisibleTime;
                }
            }
        }

        private bool mMoving = true;
        public bool Moving
        {
            get
            {
                return mMoving;
            }
            set
            {
                mMoving = value;
            }
        }

        public Rectangle Destination
        {
            get
            {
                return new Rectangle((int)Position.X, (int)Position.Y, Width, Height);
            }
        }

        public Rectangle Source
        {
            get
            {
                return new Rectangle(TexturePositionX, TexturePositionY, TextureWidth, TextureHeight);
            }
        }

        private float mVisibleTime = 0;
        public float VisibleTime
        {
            get
            {
                return mVisibleTime;
            }
            set
            {
                mVisibleTime = value;
                
            }
        }//End VisibleTime Property

        private float mElapsed = 0;
        public float Elapsed
        {
            get
            {
                return mElapsed;
            }
            set
            {
                mElapsed = value;
                if (mElapsed < 0)
                {
                    if (Flash == false)
                    {
                        mElapsed = 0;
                        mVisible = false;
                    }
                    else
                    {
                        mElapsed = mVisibleTime;
                        mVisible = !mVisible;
                    }
                }
            }
        }//End Elapsed Property

        private bool mFlash = false;
        public bool Flash
        {
            get
            {
                return mFlash;
            }
            set
            {
                mFlash = value;
            }
        }//End Flash Property

        //The position on a 2 dimensional grid
        private Vector2 mGridPosition;
        public Vector2 GridPosition
        {
            get
            {
                return mGridPosition;
            }
            set
            {
                mGridPosition = value;
            }
        }//End GridPosition Property

        //The position on a 2 dimensional grid
        public float GridPositionX
        {
            get
            {
                return GridPosition.X;
            }
            set
            {
                GridPosition = new Vector2(value, GridPosition.Y);
            }
        }//End GridPositionX Property

        //The position on a 2 dimensional grid
        public float GridPositionY
        {
            get
            {
                return GridPosition.Y;
            }
            set
            {
                GridPosition = new Vector2(GridPosition.X, value);
            }
        }//End GridPositionY Property

        public enum eDirection
        {
            None,
            Left,
            Right,
            Up,
            Down
        }

        private eDirection mDirection = eDirection.None;
        public eDirection Direction
        {
            get
            {
                return mDirection;
            }
            set
            {
                mDirection = value;
            }
        }

    }
}
