using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content;

namespace JelliesAPlenty.Text
{
    class TextManagement
    {

        public TextManagement(GraphicsDevice theGraphics, ContentManager theLoader)
        {
            FontTexture = theLoader.Load<Texture2D>("./Images/ALPHABET") as Texture2D;
        }//End New

        Dictionary<string, Text> mTexts = new Dictionary<string,Text>();
        public Dictionary<string,Text> Texts
        {
            get
            {
                return mTexts;
            }
            set
            {
                mTexts = value;
            }
        }

        Texture2D mFontTexture;
        public Texture2D FontTexture
        {
            get
            {
                return mFontTexture;
            }
            set
            {
                mFontTexture = value;
            }
        }

        public void Draw(SpriteBatch theSpriteBatch)
        {
            
            foreach (KeyValuePair<string, Text> aText in Texts) 
            {
                if (aText.Value.Visible == true)
                {
                    char[] aCharacters = aText.Value.Value.ToCharArray();
                    int aXPositionOffset = (int)aText.Value.Position.X;
                    foreach (char aChar in aCharacters)
                    {
                        theSpriteBatch.Draw(FontTexture, new Rectangle(aXPositionOffset, (int)aText.Value.Position.Y, aText.Value.Size, aText.Value.Size), new Rectangle(GetLetterValue(aChar), 0, 40, FontTexture.Height), Color.White);
                        aXPositionOffset += aText.Value.Size + 3;
                    }
                }
            }//Next Text
        }//End Draw()

        public void Draw(SpriteBatch theSpriteBatch, string theKey)
        {
            char[] aCharacters = Texts[theKey].Value.ToCharArray();
            int aXPositionOffset = (int)Texts[theKey].Position.X;
            foreach (char aChar in aCharacters)
            {
                theSpriteBatch.Draw(FontTexture, new Rectangle(aXPositionOffset, (int)Texts[theKey].Position.Y, Texts[theKey].Size, Texts[theKey].Size), new Rectangle(GetLetterValue(aChar), 0, 40, FontTexture.Height), Color.White);
                aXPositionOffset += Texts[theKey].Size + 3;
            }
        }//End Draw()
        
        //Get the position of the character in the Font texture
        protected int GetLetterValue(char theCharacter)
        {
            int aNumberPositionX = -26;
            switch (theCharacter)
            {
                case 'A':
                    aNumberPositionX = -26;
                    break;
                case 'B':
                    aNumberPositionX = -25;
                    break;
                case 'C':
                    aNumberPositionX = -24;
                    break;
                case 'D':
                    aNumberPositionX = -23;
                    break;
                case 'E':
                    aNumberPositionX = -22;
                    break;
                case 'F':
                    aNumberPositionX = -21;
                    break;
                case 'G':
                    aNumberPositionX = -20;
                    break;
                case 'H':
                    aNumberPositionX = -19;
                    break;
                case 'I':
                    aNumberPositionX = -18;
                    break;
                case 'J':
                    aNumberPositionX = -17;
                    break;
                case 'K':
                    aNumberPositionX = -16;
                    break;
                case 'L':
                    aNumberPositionX = -15;
                    break;
                case 'M':
                    aNumberPositionX = -14;
                    break;
                case 'N':
                    aNumberPositionX = -13;
                    break;
                case 'O':
                    aNumberPositionX = -12;
                    break;
                case 'P':
                    aNumberPositionX = -11;
                    break;
                case 'Q':
                    aNumberPositionX = -10;
                    break;
                case 'R':
                    aNumberPositionX = -9;
                    break;
                case 'S':
                    aNumberPositionX = -8;
                    break;
                case 'T':
                    aNumberPositionX = -7;
                    break;
                case 'U':
                    aNumberPositionX = -6;
                    break;
                case 'V':
                    aNumberPositionX = -5;
                    break;
                case 'W':
                    aNumberPositionX = -4;
                    break;
                case 'X':
                    aNumberPositionX = -3;
                    break;
                case 'Y':
                    aNumberPositionX = -2;
                    break;
                case 'Z':
                    aNumberPositionX = -1;
                    break;
                case '0':
                    aNumberPositionX = 0;
                    break;
                case '1':
                    aNumberPositionX = 1;
                    break;
                case '2':
                    aNumberPositionX = 2;
                    break;
                case '3':
                    aNumberPositionX = 3;
                    break;
                case '4':
                    aNumberPositionX = 4;
                    break;
                case '5':
                    aNumberPositionX = 5;
                    break;
                case '6':
                    aNumberPositionX = 6;
                    break;
                case '7':
                    aNumberPositionX = 7;
                    break;
                case '8':
                    aNumberPositionX = 8;
                    break;
                case '9':
                    aNumberPositionX = 9;
                    break;
                case '+':
                    aNumberPositionX = 10;
                    break;
                case '-':
                    aNumberPositionX = 11;
                    break;
                case '/':
                    aNumberPositionX = 12;
                    break;
                case '*':
                    aNumberPositionX = 13;
                    break;
                case ':':
                    aNumberPositionX = 14;
                    break;
                case ' ':
                    aNumberPositionX = 15;
                    break;
            }   

            return 40 * (26 + aNumberPositionX); 
        }//GetLetterValue()


        public void Update(float elapsed)
        {

            foreach (KeyValuePair<string, Text> aText in Texts)
            {
                if (aText.Value.VisibleTime != 0)
                {
                    aText.Value.Elapsed -= elapsed;
                }
            }

        }//End Update()

    }//Class TextManagement
}//Namespace JelliesAPlenty.Text
